Overview | Package | Class | Deprecated | Index | Help
| Groovy 1.7.0
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.groovy.ast
Class CompileUnit

    java.lang.Object
      org.codehaus.groovy.ast.CompileUnit

    class CompileUnit
    extends Object

Represents the entire contents of a compilation step which consists of one or more ModuleNode instances. There's one instance of this that's shared by all modules and classes compiled during a single invocation of the compiler. It's attached to MethodNodes and ClassNodes and is used to find fully qualified names of classes, resolve imports, and that sort of thing.

author:
  James Strachan

version:
  $Revision: 16708 $

Constructor Summary
`CompileUnit(GroovyClassLoader classLoader, CompilerConfiguration config)`
`CompileUnit(GroovyClassLoader classLoader, CodeSource codeSource, CompilerConfiguration config)`

Method Summary
`void` | `addClass(ClassNode node)` Adds a class to the unit.
`void` | `addClassNodeToCompile(ClassNode node, SourceUnit location)` this emthod actually does not compile a class.
`void` | `addClasses(List classList)` Appends all of the fully qualified class names in this module into the given map
`void` | `addModule(ModuleNode node)`
`ClassNode` | `getClass(String name)` the name does not exist in the current compilation unit (ignoring the .class files on the classpath)
`GroovyClassLoader` | `getClassLoader()`
`List` | `getClasses()`
`CodeSource` | `getCodeSource()`
`CompilerConfiguration` | `getConfig()`
`List` | `getModules()`
`SourceUnit` | `getScriptSourceLocation(String className)`
`boolean` | `hasClassNodeToCompile()`
`Iterator` | `iterateClassNodeToCompile()`

Methods inherited from class Object
wait, wait, wait, hashCode, getClass, equals, toString, notify, notifyAll

Constructor Detail

### CompileUnit

    public CompileUnit(GroovyClassLoader classLoader, CompilerConfiguration config)

### CompileUnit

    public CompileUnit(GroovyClassLoader classLoader, CodeSource codeSource, CompilerConfiguration config)

Method Detail

### addClass

    public void addClass(ClassNode node)

  Adds a class to the unit.

### addClassNodeToCompile

    public void addClassNodeToCompile(ClassNode node, SourceUnit location)

  this emthod actually does not compile a class. It's only a marker that this type has to be compiled by the CompilationUnit at the end of a parse step no node should be be left.

### addClasses

    public void addClasses(List classList)

  Appends all of the fully qualified class names in this module into the given map

### addModule

    public void addModule(ModuleNode node)

### getClass

    public ClassNode getClass(String name)

  return:
    the ClassNode for the given qualified name or returns null if the name does not exist in the current compilation unit (ignoring the .class files on the classpath)

### getClassLoader

    public GroovyClassLoader getClassLoader()

### getClasses

    public List getClasses()

  return:
    a list of all the classes in each module in the compilation unit

### getCodeSource

    public CodeSource getCodeSource()

### getConfig

    public CompilerConfiguration getConfig()

### getModules

    public List getModules()

### getScriptSourceLocation

    public SourceUnit getScriptSourceLocation(String className)

### hasClassNodeToCompile

    public boolean hasClassNodeToCompile()

### iterateClassNodeToCompile

    public Iterator iterateClassNodeToCompile()

Copyright © 2003-2009 The Codehaus. All rights reserved.